# Zabbix

## Objetivo
Criar um sistema de monitoramento com métricas em dashboards e alarmes com base nessas métricas.


## links
1. [Zabbix Downloads](https://www.zabbix.com/download)
2. [Zabbix with Nginx](https://www.erickandrade.com.br/instalando-o-zabbix-6-0-com-postgresql-e-nginx/)
3. [Postgres Custom Query](https://www.zabbix.com/forum/zabbix-help/457893-postgresql-custom-queries-pgsql-custom-query-what-is-wrong)
4. [Grafana new items](https://community.grafana.com/t/new-zabbix-item-not-showing-in-new-dashboard/24622/3)
5. [Zabbix PostgreSQL plugin](https://git.zabbix.com/projects/AP/repos/postgresql/browse?at=refs%2Fheads%2Frelease%2F7.2)


## Dependências
1. Zabbix, 7.2, Software de monitoramento
2. PostgreSQL, 17.4-1.pgdg120+2, SGBD Relacional
3. Nginx, 1.22.1-9, Web Server


## Instalação
Instale de acordo com sua distribuição na [documentação](https://www.zabbix.com/download)

Exemplo com Debian.
```bash
# Install Zabbix repository 
wget https://repo.zabbix.com/zabbix/7.2/release/debian/pool/main/z/zabbix-release/zabbix-release_latest_7.2+debian12_all.deb
dpkg -i zabbix-release_latest_7.2+debian12_all.deb
apt update 

# Install Zabbix server, frontend, agent2 
apt install zabbix-server-pgsql zabbix-frontend-php php8.2-pgsql zabbix-nginx-conf zabbix-sql-scripts zabbix-agent2 

# Install Zabbix agent 2 plugins 
apt install zabbix-agent2-plugin-mongodb zabbix-agent2-plugin-mssql zabbix-agent2-plugin-postgresql

# Create initial database
sudo -u postgres createuser --pwprompt zabbix
sudo -u postgres createdb -O zabbix zabbix
zcat /usr/share/zabbix/sql-scripts/postgresql/server.sql.gz | sudo -u zabbix psql zabbix

# Configure the database for Zabbix server in /etc/zabbix/zabbix_server.conf 
DBPassword=password 

# Start Zabbix server and agent processes 
systemctl restart zabbix-server zabbix-agent2 nginx php8.2-fpm
systemctl enable zabbix-server zabbix-agent2 nginx php8.2-fpm
```


#### nginx
1. [Zabbix with Nginx](https://www.erickandrade.com.br/instalando-o-zabbix-6-0-com-postgresql-e-nginx/)

Para acessar a interface web é necessário configurar um servidor `nginx`.

```bash
# Remove nginx default
rm /etc/nginx/sites-available/default
rm /etc/nginx/sites-enabled/default

# Remove zabbix conf
rm /etc/nginx/conf.d/zabbix.conf

# Create simbolic link to sites-available and sites-enabled
sudo ln -s /etc/zabbix/nginx.conf /etc/nginx/sites-available/default
sudo ln -s /etc/zabbix/nginx.conf /etc/nginx/sites-enabled/default

# Restart nginx
systemctl restart nginx
```

Finalmente acesse o zabbix em `http://hostname/setup.php` e configure o passo a passo.

Acesse o login padrão com usuário `Admin` e senha `zabbix`

#### Grafana
1. [Zabbix plugin](https://grafana.com/grafana/plugins/alexanderzobnin-zabbix-app/)

Para utilizar o zabbix de dentro do Grafana instale por plugin.
```bash
# Install plugin
grafana-cli plugins install alexanderzobnin-zabbix-app

# Restart server
sudo systemctl restart grafana-server.service
```

Altere o plugin para enable em `home > Administration > Plugins and data > Plugins > Zabbix`

Por fim, na conexão, especifique a URL como `http://<your_host>/api_jsonrpc.php` junto com as credenciais de acesso.